<script lang="ts">
import { Component, Prop } from 'vue-property-decorator';
import type { ScrollTo } from '@/logic/ScrollActions';
import type { Emitter } from '@/components/canvas/canvas-events';
import type {
  Onset, Pixel, Point, Unit,
} from '@/data';
import type { BCursorMoveRegisterer } from '../player/BCanvasCursor.vue';
import LabelBehavior from '../LabelBehavior.vue';

@Component
export default class BScrollCursorOnKey extends LabelBehavior<Emitter, BCursorMoveRegisterer> {
  @Prop()
  scrollTo!: ScrollTo;

  @Prop()
  pixelUnit!: Unit<Pixel>;

  currentCursorPosition: Point = { x: 0, y: 0 } as Point;

  onKey(e: KeyboardEvent) {
    if (e.key === '.') {
      const cursorOnset = this.pixelUnit.toOnset(this.currentCursorPosition.x).value;
      this.scrollTo({
        x: this.pixelUnit.fromOnset(cursorOnset - 5 as Onset).value,
        y: 0,
      } as Point);
    }
  }

  mounted() {
    this.register('cursor-move', (evt) => {
      this.currentCursorPosition = evt;
    });
    this.register('document-keydown', this.onKey);
    this.register('document-shift-keydown', this.onKey);
  }
}
</script>
